﻿using System.Collections.Generic;
using Newtonsoft.Json;

namespace Jsdl.Domain
{
	public class Service
	{
		public Service()
		{
			Operations = new Dictionary<string, Operation>();
			Types = new List<ServiceType>();
		}

		[JsonProperty(PropertyName = "operations")]
		public Dictionary<string, Operation> Operations { get; set; }

		[JsonProperty(PropertyName = "types")]
		public List<ServiceType> Types { get; set; }
	}
}