﻿using System;
using System.IO;
using System.ServiceModel;
using JsdlSampleWeb.Domain;

namespace JsdlSampleWeb.Services
{
	[ServiceContract]
	public class DataService
	{
		[OperationContract]
		public decimal Sum(decimal a, decimal b)
		{
			//throw new FileNotFoundException("sample exception");
			return a + b; 
		}

		[OperationContract]
		public Person GetPerson(int id)
		{
			return new Person { FirstName = "Foo", LastName = "Bar" };
		}

		[OperationContract]
		public void UpdatePerson(Person person)
		{
			
		}
	}
}
