﻿using System;

namespace Jsdl
{
	public class JsdlException : Exception
	{
		public JsdlException(string code)
		{
			Code = code;
		}

		public JsdlException(string code, string message)
			: base(message)
		{
			Code = code;
		}

		public string Code { get; private set; }
	}
}
