﻿using System;
using Windows.UI.Popups;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Navigation;

namespace JsdlSampleApp
{
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            InitializeComponent();
        }

        protected async override void OnNavigatedTo(NavigationEventArgs e)
        {
			var svc = new DataService("http://localhost:4338/JsdlServices/");
			var sum = await svc.SumAsync(1, 2);
			await new MessageDialog("Sum", sum.ToString()).ShowAsync();
        }
    }
}
